<template>
  <div class="drop-shade">
    <div class="reset-form">
      <div v-if="!error && !result && !resetting">
        <h3>Reset Password</h3>
        <el-input
          type="password"
          v-model="password"
          placeholder="New Password"
        />
        <el-button @click="reset" v-if="password">Reset Password</el-button>
      </div>
      <div v-else-if="resetting">Resetting...</div>
      <div v-else-if="result">
        <div v-if="result.resetPassword.success">Password reset success!</div>
        <div v-else>Not success :( Invalid token? Try again?</div>
      </div>
      <div v-else-if="error">
        {{ error }}
      </div>
      <div v-else>Unknown state...</div>
    </div>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";

.reset-form {
  max-width: $grid * 10;
  pointer-events: initial;
}
</style>
<script>
export default {
  layout: "logged-out",
  data() {
    return { error: null, result: null, resetting: false, password: null };
  },
  mounted() {
    if (!this.$route.query.user_id || !this.$route.query.token) {
      return (this.error =
        "Invalid reset link, check your email and try again.");
    }
  },
  methods: {
    async reset() {
      this.resetting = true;
      const { error, result } = await this.$gql(
        `
    mutation($userId:Int! $token:String! $password:String!) {
  resetPassword(input: { userId:$userId resetToken:$token newPassword:$password }) {
    success
  }
}
    `,
        {
          userId: Number(this.$route.query.user_id),
          token: this.$route.query.token,
          password: this.password,
        }
      );

      this.error = error;
      this.result = result;
      this.resetting = false;
    },
  },
};
</script>
